moMouseKeyEvents = {};
source(MultiOverlayV3.modDir.."mouseKeyEvents/moMouseKeyMohPDA.lua");
source(MultiOverlayV3.modDir.."mouseKeyEvents/moMouseKeyMohSLOT.lua");
source(MultiOverlayV3.modDir.."mouseKeyEvents/moMouseKeyMohIconPreviewPDA.lua");

function moMouseKeyEvents:setKeyMouse(self, unicode, sym, modifier, isDownKey, posX, posY, isDown, isUp, button)
	if not moGeneralSettings.modOn and unicode ~= nil then moMouseKeyEvents:setKey(self, unicode, sym, modifier, isDownKey, true); return;end;
	if unicode ~= nil then
		if not MultiOverlayV3.dragDropPos.on and not g_currentMission.guiMenue.dragDrop.on then
			moMouseKeyEvents:setKey(self, unicode, sym, modifier, isDownKey, false);			
		end;
	else
		if moGeneralSettings.setMouseCursor then
			if not MultiOverlayV3.dragDropPos.on and not g_currentMission.guiMenue.dragDrop.on then
				moMouseKeyEvents:setMouse(self, posX, posY, isDown, isUp, button);
			elseif MultiOverlayV3.dragDropPos.on then
				moMouseKeyEvents:setDragDropMouse(self, posX, posY, isDown, isUp, button, MultiOverlayV3.dragDropPos.whatDragDrop);
			end;
		end;
	end;
end;

function moMouseKeyEvents:setMouse(self, posX, posY, isDown, isUp, button)
	local whichSubPDA = "masterPDA_";	
	local openMohPDAs = moSetGetMohPDA:getOpenPDAs();	
	if #openMohPDAs > 0 then
		for pda=1, #openMohPDAs do
			whichSubPDA = openMohPDAs[pda];			
			if not moSetGetOverlays.pda[whichSubPDA].smallView and button == Input.MOUSE_BUTTON_WHEEL_UP and isDown then							
				if moGeneralSettings.clickAreas.pda[whichSubPDA] ~= nil and #moGeneralSettings.clickAreas.pda[whichSubPDA] > 0 then
					for a=1, #moGeneralSettings.clickAreas.pda[whichSubPDA] do
						if moGeneralSettings.clickAreas.pda[whichSubPDA][a] ~= nil then					
							if MultiOverlayV3:mouseIsInArea(posX, posY, unpack(moGeneralSettings.clickAreas.pda[whichSubPDA][a]))then
								
								--if moGeneralSettings.clickAreas.pda[whichSubPDA][a].whereClick == "masterPDA_" and not moSetGetOverlays.pda[whichSubPDA].smallView then
									moSetGetOverlays.pda[whichSubPDA].smallView = false;moSetGetOverlays.pda[whichSubPDA].hidden.inactiveTimer=0;
									moMouseKeyMohPDA:setEventButtonScroll(self, moGeneralSettings.clickAreas.pda[whichSubPDA][a], true, nil, whichSubPDA);							
								--end;
							end;
						end;
					end;
				end;
				return;
			elseif not moSetGetOverlays.pda[whichSubPDA].smallView and button == Input.MOUSE_BUTTON_WHEEL_DOWN and isDown then							
				if moGeneralSettings.clickAreas.pda[whichSubPDA] ~= nil and #moGeneralSettings.clickAreas.pda[whichSubPDA] > 0 then
					for a=1, #moGeneralSettings.clickAreas.pda[whichSubPDA] do
						if moGeneralSettings.clickAreas.pda[whichSubPDA][a] ~= nil then					
							if MultiOverlayV3:mouseIsInArea(posX, posY, unpack(moGeneralSettings.clickAreas.pda[whichSubPDA][a]))then						
								--if moGeneralSettings.clickAreas.pda[whichSubPDA][a].whereClick == "masterPDA_" and not moSetGetOverlays.pda[whichSubPDA].smallView then							
									moSetGetOverlays.pda[whichSubPDA].smallView = false;moSetGetOverlays.pda[whichSubPDA].hidden.inactiveTimer=0;
									moMouseKeyMohPDA:setEventButtonScroll(self, moGeneralSettings.clickAreas.pda[whichSubPDA][a], nil, true, whichSubPDA);							
								--end;
							end;
						end;
					end;
				end;
				return;			
			end;
			
			--elseif button == Input.MOUSE_BUTTON_LEFT and isDown then
				if moGeneralSettings.clickAreas.pda[whichSubPDA] ~= nil and #moGeneralSettings.clickAreas.pda[whichSubPDA] > 0 then
					for a=1, #moGeneralSettings.clickAreas.pda[whichSubPDA] do
						if moGeneralSettings.clickAreas.pda[whichSubPDA][a] ~= nil then					
							if MultiOverlayV3:mouseIsInArea(posX, posY, unpack(moGeneralSettings.clickAreas.pda[whichSubPDA][a]))then
								--if moGeneralSettings.clickAreas.pda[whichSubPDA][a].whereClick == "masterPDA_" then
									if moGeneralSettings.clickAreas.pda[whichSubPDA][a].whatClick == "hiddenArea" then
										moSetGetOverlays.pda[whichSubPDA].smallView = false;moSetGetOverlays.pda[whichSubPDA].hidden.inactiveTimer=0;
										return;
									end;
									if button == Input.MOUSE_BUTTON_LEFT and isDown then																			
										moDraw.infoHelpBox.reset();
										moSetGetOverlays.pda[whichSubPDA].smallView = false;moSetGetOverlays.pda[whichSubPDA].hidden.inactiveTimer=0;								
										moMouseKeyMohPDA:setEventButtonLeft(self, moGeneralSettings.clickAreas.pda[whichSubPDA][a], whichSubPDA, "mouseButtonLeft");
										break;									
									elseif button == Input.MOUSE_BUTTON_MIDDLE and isDown then							
										moSetGetOverlays.pda[whichSubPDA].smallView = false;moSetGetOverlays.pda[whichSubPDA].hidden.inactiveTimer=0;								
										moMouseKeyMohPDA:setEventButtonMiddle(self, moGeneralSettings.clickAreas.pda[whichSubPDA][a], whichSubPDA, "mouseButtonMiddle");
										break;												
									elseif button == Input.MOUSE_BUTTON_RIGHT and isDown then							
										moSetGetOverlays.pda[whichSubPDA].smallView = false;moSetGetOverlays.pda[whichSubPDA].hidden.inactiveTimer=0;								
										moMouseKeyMohPDA:setEventButtonRight(self, moGeneralSettings.clickAreas.pda[whichSubPDA][a], whichSubPDA, "mouseButtonRight");
										break;									
									end;
								--end;
							end;
							
						end;
					end;
				end;
			--end;
		end;
	end;
	local whichSubSLOT = "masterSLOT_";
	local openMohSlots = moSetGetMohSLOT:getOpenSLOTs();
	if #openMohSlots > 0 then
		for slot=1, #openMohSlots do
			whichSubSLOT = openMohSlots[slot];
			if moGeneralSettings.clickAreas.slot[whichSubSLOT] ~= nil and #moGeneralSettings.clickAreas.slot[whichSubSLOT] > 0 then
				for a=1, #moGeneralSettings.clickAreas.slot[whichSubSLOT] do
					if moGeneralSettings.clickAreas.slot[whichSubSLOT][a] ~= nil then					
						if MultiOverlayV3:mouseIsInArea(posX, posY, unpack(moGeneralSettings.clickAreas.slot[whichSubSLOT][a]))then
							if button == Input.MOUSE_BUTTON_LEFT then								
								if isDown then	
									moMouseKeyMohSLOT:setEventButtonLeft(self, moGeneralSettings.clickAreas.slot[whichSubSLOT][a], whichSubSLOT, "mouseButtonLeft");
								end;
							elseif button == Input.MOUSE_BUTTON_MIDDLE and isDown then
								if isDown then	
									moMouseKeyMohSLOT:setEventButtonMiddle(self, moGeneralSettings.clickAreas.slot[whichSubSLOT][a], whichSubSLOT, "mouseButtonMiddle");
								end;
							elseif button == Input.MOUSE_BUTTON_RIGHT and isDown then
								if isDown then	
									moMouseKeyMohSLOT:setEventButtonRight(self, moGeneralSettings.clickAreas.slot[whichSubSLOT][a], whichSubSLOT, "mouseButtonRight");
								end;													
							elseif button == Input.MOUSE_BUTTON_WHEEL_UP then								
								moMouseKeyMohSLOT:setEventButtonScroll(self, isDown, moGeneralSettings.clickAreas.slot[whichSubSLOT][a], true, false, whichSubSLOT);								
							elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN then
								moMouseKeyMohSLOT:setEventButtonScroll(self, isDown, moGeneralSettings.clickAreas.slot[whichSubSLOT][a], false, true, whichSubSLOT);
							elseif moGeneralSettings.clickAreas.slot[whichSubSLOT][a].whatClick == "widthHeightZoomSlot" then
								moSetGetOverlays.slot[whichSubSLOT].design["widthHeightZoom"].visible = true;
							end;	
						end;
					end;
				end;				
			end;
		end;
	end;
	if moSetGetOverlays.iconPreviewPDA.isOpen and g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) and moGeneralSettings.clickAreas.previewIcons ~= nil and #moGeneralSettings.clickAreas.previewIcons > 0 then
		whichSubPDA = g_currentMission.guiMenue.master.getSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, true, true, nil);
		for a=1, #moGeneralSettings.clickAreas.previewIcons do
			if moGeneralSettings.clickAreas.previewIcons[a] ~= nil then
				if MultiOverlayV3:mouseIsInArea(posX, posY, unpack(moGeneralSettings.clickAreas.previewIcons[a]))then
					if button == Input.MOUSE_BUTTON_LEFT and isDown then
						moMouseKeyMohIconPreviewPDA:setEventButtonLeft(self, false, moGeneralSettings.clickAreas.previewIcons[a], whichSubPDA, "mouseButtonLeft")
					elseif button == Input.MOUSE_BUTTON_RIGHT and isDown then
						
					else
						moMouseKeyMohIconPreviewPDA:setEventButtonLeft(self, true, moGeneralSettings.clickAreas.previewIcons[a], whichSubPDA, "mouseButtonLeft")
					end;
				end;
			end;
		end;
	end;	
end;

function moMouseKeyEvents:setDragDropMouse(self, posX, posY, isDown, isUp, button, whatDragDrop)	
	if button == Input.MOUSE_BUTTON_LEFT and isDown then
		if MultiOverlayV3.dragDropPos.on then
			MultiOverlayV3:stopDragDrop(self);			
			return;						
		end;
	end;
end;

function moMouseKeyEvents:closeGui(yes)	
end;

function moMouseKeyEvents:openGui()	
end;

moMouseKeyEvents.saveGui = function (...) 
	if ... ~= nil and type(...) == "table" then
		local args = ...;				
		for arg,v in pairs(args) do
			if arg == "inputText" then				
			end;
		end;			
	end;
end;

function moMouseKeyEvents:setKeyMouseTest(self, unicode, sym, modifier, isDownKey, posX, posY, isDown, isUp, button)
	function onToggleStore()
		if not g_currentMission.isSynchronizingWithPlayers then
			if not g_currentMission.missionInfo:isa(FSCareerMissionInfo) then
				g_gui:showInfoDialog({
					text = g_i18n:getText("dialog_shopOnlyWorksInCareer")
				})
			end

			if (not g_isPresentationVersion or g_isPresentationVersionShopEnabled) and g_currentMission.missionInfo:isa(FSCareerMissionInfo) and not g_currentMission.isPlayerFrozen and g_currentMission.player.farmId ~= FarmManager.SPECTATOR_FARM_ID then
				if GS_IS_CONSOLE_VERSION then
					g_currentMission:calculateSlotUsage()
				end

				g_gui:changeScreen(nil, ShopMenu)
			end
		end
	end
	
		

		--if g_currentMission.isRunning and not g_gui:getIsGuiVisible() and g_flightAndNoHUDKeysEnabled and sym == Input.KEY_o and isDownKey then
		--	--g_currentMission.hud:setIsVisible(not g_currentMission.hud:getIsVisible())
		--	print("no hud 1")
		--end

		--if g_gui.currentGui ~= nil and g_flightAndNoHUDKeysEnabled and g_currentMission.isRunning and sym == Input.KEY_o and isDownKey and g_gui.currentGui.target == g_shopConfigScreen then
		--	--g_shopConfigScreen:toggleHUDVisible()
		--	print("no hud 2")
		--end
	
	
	if Input.isKeyPressed(Input.KEY_f12) then
		if moGeneralSettings.testModus then 
			if moGeneralSettings.testDraw then
				moGeneralSettings.testDraw = false;
			else
				moGeneralSettings.testDraw = true;
			end;
		end;
		print(DebugUtil.printTableRecursively(g_splitTypeManager, "splitTypeManager ", 0, 5))
		for key, value in pairs(g_splitTypeManager) do
			print("g_splitTypeManager key und value ...".. tostring(key).. "-----".. tostring(value))										
		end;
		--elements
		if test then
		test = false;		
		local vehiclesLength = Utils.getNoNil(#g_currentMission.enterables, 0);
		for v=1, vehiclesLength do 
			local vehicle = g_currentMission.enterables[v];
			local typeName = Utils.getNoNil(string.lower(vehicle.typeName), "Unknown");
			print("typename ".. tostring(typeName))			
			if g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle == vehicle then
				local typeDef = g_vehicleTypeManager:getVehicleTypeByName(vehicle.typeName);
				print("typeDef ".. tostring(typeDef))
				local xmlVehicle = Utils.getNoNil(vehicle.configFileName, vehicle.xmlFile);					
				local storeItem = g_storeManager:getItemByXMLFilename(xmlVehicle:lower()); --new LS19 !!!							
				if storeItem ~= nil and xmlVehicle ~= nil and storeItem.imageFilename ~= "data/store/store_empty.png" then
					--print(DebugUtil.printTableRecursively(vehicle, "vehicle debug ", 0, 1))
					for key, value in pairs(storeItem) do
						print("storeItem key und value ...".. tostring(key).. "-----".. tostring(value))	
										
					end;						
				end;
			end;
		end;
		end;
		
		--FSBaseMission:onToggleStore();
		--g_currentMission.shopMenu.currentPageName = "garageOwned";
		--g_currentMission.shopMenu.currentPageId = 2;
		--onToggleStore();
		--ShopMenu.lastGaragePage = ShopMenu.pageShopGarageOwned
		--TabbedMenuWithDetails:onOpen(ShopMenu.pagingElement)		
		--ShopMenu:updateGarageButtonInfo(ShopMenu.lastGaragePage, true, 0, false)
		--ShopMenu:pushDetail(ShopMenu.lastGaragePage)
		
		--ShopMenu:onButtonGarage()	
		--InGameMenu:onMenuOpened();
		--g_currentMission.inGameMenu.currentPageId = 4;
		--g_currentMission.inGameMenu.currentPageName = "garageOverview";
		--InGameMenuVehiclesFrame:onOpen()
		--InGameMenuVehiclesFrame:onFrameOpen()
		--ShopMenu:onButtonGarage()
		--function getIsOnField()
		--    local x, y, z = g_currentMission.player:getPositionData();
			---local wx,wy,wz = getWorldTranslation(vehicle.components[1].node);
		--    local densityBits = getDensityAtWorldPos(g_currentMission.terrainDetailId, x, y, z);
		--   return densityBits, densityBits ~= 0;
		--end;		
		--moGeneralSettings.testString = tostring(getIsOnField())
		if test then 
			test = false;
			for key, value in pairs(g_missionManager.missions) do
				print("g_missionManager.missions key und value ...".. tostring(key).. "-----".. tostring(value))
				for key1, value1 in pairs(value) do
					print("g_missionManager.missions under Table key und value ...".. tostring(key1).. "-----".. tostring(value1))
					if key1 == "type" then
						for key2, value2 in pairs(value1) do
							print("g_missionManager.missions.type under Table key und value ...".. tostring(key2).. "-----".. tostring(value2))							
							if key2 == "class" then
								for key3, value3 in pairs(value2) do
									print("g_missionManager.missions.class under Table key und value ...".. tostring(key3).. "-----".. tostring(value3))							
									
								end;
							end;
						end;
					end;
				end;
			end;			
		end;
	end;
end;

function moMouseKeyEvents:setKey(self, unicode, sym, modifier, isDown, onlyMouse, cursorOnOff)
	--InputAction	
	if cursorOnOff then
		if moGeneralSettings.setMouseCursor then
			moMouseKeyEvents:setMouseCursorAndFrozen(self, false);
			moMouseKeyMohSLOT:settingSlot(nil, true);
		else
			moMouseKeyEvents:setMouseCursorAndFrozen(self, true)
			if not g_currentMission.hud.isVisible and MultiOverlayV3.noHudApp ~= nil and MultiOverlayV3.noHudApp.isActive ~= nil and MultiOverlayV3.noHudApp.isActive then MultiOverlayV3.noHudApp.onOff();end;
		end;
		if onlyMouse then moMouseKeyMohPDA:openSetting(self, nil, 1);end;
		return;	
	end;
end;

function moMouseKeyEvents:setMouseCursorAndFrozen(self, enable, onlyFrozen)
	if enable then
		if not g_currentMission.isPlayerFrozen and moGeneralSettings.setFrozen then
			g_currentMission.isPlayerFrozen = true;			
			g_currentMission.isFrozen = true;
		end;
		moGeneralSettings.setMouseCursor = true;
		g_currentMission.isMouse = true;		
		g_inputBinding:setShowMouseCursor(true);		
	elseif onlyFrozen then
		if not g_currentMission.isPlayerFrozen and moGeneralSettings.setFrozen then
			g_currentMission.isPlayerFrozen = true;			
			g_currentMission.isFrozen = true;
		elseif g_currentMission.isPlayerFrozen and not moGeneralSettings.setFrozen then
			g_currentMission.isFrozen = false;			
			g_currentMission.isPlayerFrozen = false;		
		end;
	else
		if g_currentMission.isPlayerFrozen and moGeneralSettings.setFrozen then
			g_currentMission.isFrozen = false;			
			g_currentMission.isPlayerFrozen = false;
		end;		
		moGeneralSettings.setMouseCursor = false;
		if moGeneralSettings.autoMouseCursor.off then moSetGetExtras:removeTimer("mouseCursorOff");end;
		g_currentMission.isMouse = false;		
		g_inputBinding:setShowMouseCursor(false);		
		moGeneralSettings.clickAreas.pda = {};
		moGeneralSettings.clickAreas.slot = {};
		moGeneralSettings.clickAreas.simpleAppPDA = {};
		moGeneralSettings.clickAreas.previewIcons = {};
	end;
end;

function moMouseKeyEvents:coursorAutoOffTimer()
	if moGeneralSettings.setMouseCursor then
		if not moGeneralSettings.autoMouseCursor.off or MultiOverlayV3.guiMenue.on == nil or g_currentMission.guiMenue.master.isOpen() then return;end;
		if MultiOverlayV3.timers["mouseCursorOff"] ~= nil then return;end;
		moSetGetExtras:addTimer( {delay=moGeneralSettings.autoMouseCursor.timer, name="mouseCursorOff", repeatable=1, ms=false, action=moMouseKeyEvents.disableMouseCursor} );
	end;	
end;

function moMouseKeyEvents.disableMouseCursor()
	if not moGeneralSettings.setMouseCursor or g_currentMission.guiMenue.master.isOpen() then return;end;
	moMouseKeyEvents:setKey(self, nil, nil, nil, nil, false, true);
end;