moGuiMenueClick = {};

--optional, better over Gui Menue and g_currentMission.guiMenue.master.getYourMenue(modMenueName)
function moGuiMenueClick:getYourMenue(self, modMenueName)
	if g_currentMission.guiMenue.modTable ~= nil and #g_currentMission.guiMenue.modTable > 0 then		 
		for a=1, #g_currentMission.guiMenue.modTable do
			if g_currentMission.guiMenue.modTable[a].name == tostring(modMenueName) and string.len(g_currentMission.guiMenue.modTable[a].name) == string.len(tostring(modMenueName)) then
				return a;				
			end;
		end;
	end;
	return 0;
end;

--optional, better over Gui Menue and g_currentMission.guiMenue.master.isReturnClick(modMenueTable)
function moGuiMenueClick:isReturnClick(self, byName, byLineButton)
	if byName then
		return string.len(g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].returnClick.name) > 0;
	elseif byLineButton then	
		return g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].returnClick.line > 0 and g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].returnClick.button > 0;
	end;
end;

--optional, better over Gui Menue and g_currentMission.guiMenue.master.resetReturnClick(modMenueTable)
function moGuiMenueClick:resetReturnClick(self)	
	g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].returnClick = {name="",line=0, button=0};
end;



function moGuiMenueClick:setReturnClick(self) 	
	
	local returnClick = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].returnClick.name;
	if string.find(returnClick, "openModMasterPage_") or string.find(returnClick, "openModMasterPageSide_") then return;end; --Stop this Click, Master Pages running over Gui Menue onOpen/Close Callback in ...generateModMenuePage...
	
	local clickLine = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].returnClick.line;
	local clickButton = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].returnClick.button;			
	local isPullDownOpen = g_currentMission.guiMenue.master.isPullDownOpen(); --is a pullDownMenue Open or Not (global for all) ---> check is pullDownOpen or not with	 
	local masterPage = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].lastOpenPage.masterPage;
	local slavePage = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].lastOpenPage.slavePage;
	local pageSide = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].lastOpenPage.pageSide;	
	local whichSubPDA = g_currentMission.guiMenue.master.getSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, true, true, nil);	
	
	if whichSubPDA ~= nil and string.find(returnClick, "openModSlavePage") and g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, "tabletPDAs_", true, nil ,nil) then --set Slave Pages Gui Menue Click "tablePDAs"
		moSetGetMohPDA.setOpenCloseSettingsPDA(whichSubPDA, true, nil);
	end;
	
	if g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, "globalSettingsSide1_", true, nil ,true) then --MultiOverlayV3 Global Settings Side 1
		globalSettingsSide1:setReturnClick(self, returnClick, whichSubPDA, isPullDownOpen, clickLine, clickButton, masterPage, slavePage, pageSide, virtualReturnClick);
		return;
	end;
	if g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, "slotSettingsSide1_", true, nil ,true) then --MultiOverlayV3 Slot Settings Side 1
		slotSettingsSide1:setReturnClick(self, returnClick, whichSubPDA, isPullDownOpen, clickLine, clickButton, masterPage, slavePage, pageSide, virtualReturnClick);
		return;
	end;
	if g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, "otherSettingsSide1_", true, nil ,true) then --MultiOverlayV3 Other Settings Side 1
		otherSettingsSide1:setReturnClick(self, returnClick, whichSubPDA, isPullDownOpen, clickLine, clickButton, masterPage, slavePage, pageSide, virtualReturnClick);
		return;
	end;
	if g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, "moduleMohSettingsSide1_", true, nil ,true) then --MultiOverlayV3 Module(Moh) Settings Side 1
		moduleMohSettingsSide1:setReturnClick(self, returnClick, whichSubPDA, isPullDownOpen, clickLine, clickButton, masterPage, slavePage, pageSide, virtualReturnClick);
		return;
	end;
	if g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, "pdaSlotGlobalSide1_", true, nil ,true) then --Global PDA Settings
		pdaSlotGlobalSide1:setReturnClick(self, returnClick, whichSubPDA, isPullDownOpen, clickLine, clickButton, masterPage, slavePage, pageSide, virtualReturnClick);
		return;
	end;
	if whichSubPDA == nil or string.len(whichSubPDA) < 1 then return;end;
	if string.find(whichSubPDA, "PDA_") and g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, whichSubPDA, true, true, nil) then
		if moSetGetOverlays.pda[whichSubPDA] == nil then return;end;		
		if pageSide == 1 then 		
			tabletPdaDefaultSide1:setReturnClick(self, returnClick, whichSubPDA, isPullDownOpen, clickLine, clickButton, masterPage, slavePage, pageSide, virtualReturnClick);
		elseif pageSide == 2 then
			tabletPdaDefaultSide2:setReturnClick(self, returnClick, whichSubPDA, isPullDownOpen, clickLine, clickButton, masterPage, slavePage, pageSide, virtualReturnClick);
		elseif pageSide == 3 then
			tabletPdaDefaultSide3:setReturnClick(self, returnClick, whichSubPDA, isPullDownOpen, clickLine, clickButton, masterPage, slavePage, pageSide, virtualReturnClick);
		end;
	end;
	return;
end;
