moDraw.mohPDA = {};

function moDraw.mohPDA:setOpenDraw(self, whichPDA)	
	local whichSubPDA = whichPDA or "masterPDA_";
	if moSetGetOverlays.pda[whichSubPDA] == nil or moSetGetOverlays.pda[whichSubPDA].design[1] == nil then return;end;
	moGeneralSettings.clickAreas.pda[whichSubPDA] = {};
	local horizontal = moSetGetOverlays.pda[whichSubPDA].design[5].width;
	local vertical = moSetGetOverlays.pda[whichSubPDA].design[5].height;
	local horizontalSmall = moSetGetOverlays.pda[whichSubPDA].design[5].width/2;
	local verticalSmall = moSetGetOverlays.pda[whichSubPDA].design[5].height/2;
	local posX = moSetGetOverlays.pda[whichSubPDA].manuPosX or moSetGetOverlays.pda[whichSubPDA].pos.x;
	local posY = moSetGetOverlays.pda[whichSubPDA].manuPosY or moSetGetOverlays.pda[whichSubPDA].pos.y;
	local distanceAppIconWidth = (moSetGetOverlays.pda[whichSubPDA].design[5].width-(moSetGetOverlays.buttonGfxWidth1*moSetGetOverlays.pda[whichSubPDA].zoomOutInTemp*8))/2;
	local distanceAppIconHeight = (moSetGetOverlays.pda[whichSubPDA].design[5].height-(moSetGetOverlays.buttonGfxHeight1*moSetGetOverlays.pda[whichSubPDA].zoomOutInTemp*8))/2;	
	local horizontalTxtDistance = 0.001;
	local verticalTxtDistance = 0.001;
	local newPosX = 0;
	local newPosY = 0;
	local width = 0;
	local height = 0;
	--local viewLine = getViewLine(self);
	local viewLines = #moSetGetOverlays.pda[whichSubPDA].renderViewLines;
	local appsAtMasterLine = moSetGetOverlays.pda[whichSubPDA].viewApps; --moSetGetOverlays.pda[whichSubPDA].line[1].appsAtLine;	
	--local appsAtLine = moSetGetOverlays.pda[whichSubPDA].line[viewLine].appsAtLine;
	
	if MultiOverlayV3.dragDropPos.on and MultiOverlayV3.dragDropPos.whatDragDrop == whichSubPDA then
		moSetGetOverlays.pda[whichSubPDA].manuPosX = MultiOverlayV3.mouseCursor.posX;
		moSetGetOverlays.pda[whichSubPDA].manuPosY = MultiOverlayV3.mouseCursor.posY+moSetGetOverlays.pda[whichSubPDA].height-verticalSmall;
	end;
	
	if not g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) and moSetGetOverlays.pda[whichSubPDA].hidden.auto and not moSetGetOverlays.pda[whichSubPDA].smallView then 
		moSetGetOverlays.pda[whichSubPDA].hidden.inactiveTimer = moSetGetOverlays.pda[whichSubPDA].hidden.inactiveTimer+1;
		--local getTimer = tostring(moSetGetOverlays.pda[whichSubPDA].hidden.timer).. "sec"
		--if moSetGetExtras:runsTimer(getTimer) then moSetGetOverlays.pda[whichSubPDA].smallView = true;end;
		if moSetGetOverlays.pda[whichSubPDA].hidden.inactiveTimer >= moGeneralSettings.timer["isTimer"..  moSetGetOverlays.pda[whichSubPDA].hidden.timer] then
			moSetGetOverlays.pda[whichSubPDA].smallView = true;
		end;
	elseif g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then
		moSetGetOverlays.pda[whichSubPDA].smallView = false;
		moSetGetOverlays.pda[whichSubPDA].hidden.inactiveTimer = 0;
	end;
	local isHidden = moSetGetOverlays.pda[whichSubPDA].smallView;
	if isHidden then viewLines = 0;appsAtMasterLine = 2;end;
	
	function getUpDownY(y, values, values1)
		local upDownY = 0;
		values1 = values1 or 0;
		if moSetGetOverlays.pda[whichSubPDA].pos.up and moSetGetOverlays.pda[whichSubPDA].manuPosY == nil then
			upDownY = y-values-values1;
		elseif moSetGetOverlays.pda[whichSubPDA].manuPosY ~= nil then
			if y >= 0.5 then 
				upDownY = y-values-values1;
			else
				upDownY = y+values+values1;
			end;
		elseif not moSetGetOverlays.pda[whichSubPDA].pos.up then
			upDownY = y+values+values1;		
		end;		
		return y-values-values1; --upDownY;
	end;
	
	--1=linksOben,2=mitteOben,3=rechtsOben
	--4=linksMitte,5=mitte,6=rechtsMitte
	--7=linksUnten,8=mitteUnten,9=rechtsUnten
	--10=keyAppSelect Rahmen 1 keySelect (for keyControl)
	--11=keyAppSelect Rahmen 2 settingAppSelect
	
	moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[1], posX, posY);
	moSetGetOverlays.pda[whichSubPDA].design[1]:render();	
	width = width+(moSetGetOverlays.pda[whichSubPDA].design[1].width*2);
	height = height+(moSetGetOverlays.pda[whichSubPDA].design[1].height);
	newPosX = posX+moSetGetOverlays.pda[whichSubPDA].design[1].width;
	newPosY = getUpDownY(posY, moSetGetOverlays.pda[whichSubPDA].design[1].height);
	moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[3], newPosX+(horizontal*appsAtMasterLine), posY);
	moSetGetOverlays.pda[whichSubPDA].design[3]:render();
		
	for a=1, viewLines do
		height = height+moSetGetOverlays.pda[whichSubPDA].design[4].height;
		moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[4], posX, getUpDownY(posY, vertical*a));
		moSetGetOverlays.pda[whichSubPDA].design[4]:render();		
		moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[6], newPosX+(horizontal*appsAtMasterLine), getUpDownY(posY, vertical*a));
		moSetGetOverlays.pda[whichSubPDA].design[6]:render();		
	end;	
	moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[7], posX, getUpDownY(newPosY, vertical*viewLines));
	moSetGetOverlays.pda[whichSubPDA].design[7]:render();
	if not g_currentMission.guiMenue.dragDrop.on and moGeneralSettings.setMouseCursor and not isHidden and g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, whichSubPDA, true, true, nil) then--guiMenueSettings:isSelectPageGlobalName(self, whichSubPDA) then
		moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["dragDrop"], posX, getUpDownY(newPosY, vertical*viewLines));
		if not MultiOverlayV3.dragDropPos.on then
			moSetGetOverlays:setBackgroundColor(moSetGetOverlays.pda[whichSubPDA].design["dragDrop"], moColors.intern["green"]);			
		else
			moSetGetOverlays:setBackgroundColor(moSetGetOverlays.pda[whichSubPDA].design["dragDrop"], moColors.intern["red"]);			
		end;
		moSetGetOverlays.pda[whichSubPDA].design["dragDrop"]:render();
		moDraw.mohPDA:clickAreas(self, posX, posX+moSetGetOverlays.pda[whichSubPDA].design[7].width, moSetGetOverlays.pda[whichSubPDA].design[7].y, moSetGetOverlays.pda[whichSubPDA].design[7].y+(moSetGetOverlays.pda[whichSubPDA].design[7].height), "dragDrop", nil, whichSubPDA);
	end;		
	
	moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[9], newPosX+(horizontal*appsAtMasterLine), getUpDownY(newPosY, vertical*viewLines));
	moSetGetOverlays.pda[whichSubPDA].design[9]:render();
	
	for a=1, appsAtMasterLine do
		width = width+moSetGetOverlays.pda[whichSubPDA].design[2].width;
		moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[2], newPosX+(horizontal*(a-1)), posY);
		moSetGetOverlays.pda[whichSubPDA].design[2]:render();		
		moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[8], newPosX+(horizontal*(a-1)), getUpDownY(newPosY, vertical*viewLines));
		moSetGetOverlays.pda[whichSubPDA].design[8]:render();
		for b=1, viewLines do			
			moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[5], newPosX+(horizontal*(a-1)), getUpDownY(posY, vertical*b));
			moSetGetOverlays.pda[whichSubPDA].design[5]:render();
						
			if not isHidden and ((g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) and not g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, whichSubPDA, true, true, nil)) or not g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable)) and moSetGetOverlays.pda[whichSubPDA].keyControl and moSetGetOverlays.pda[whichSubPDA].keySelect.pda == 1 and moSetGetOverlays.pda[whichSubPDA].keySelect.line == b and moSetGetOverlays.pda[whichSubPDA].keySelect.app == a then
				moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[10], newPosX+(horizontal*(a-1)), getUpDownY(posY, vertical*b));
				moSetGetOverlays.pda[whichSubPDA].design[10]:render();
			end;			
		end;
	end;
	
	--test saveButton	
	--moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["save"], newPosX+(horizontal*(appsAtMasterLine-0.5)), posY);
	--moSetGetOverlays.pda[whichSubPDA].design["save"]:render();	
	--test saveButton
	
	local tempViewLines = 1;	
	function setAppIcons(renderLine)
		if moSetGetOverlays.pda[whichSubPDA].line[renderLine].view and tempViewLines <= viewLines then			
			local buttonTable = nil;
			local selectSettingLine = 0;
			local appSettingSelect = 0;
			if moGeneralSettings.setMouseCursor then
				if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app ~= nil and #moSetGetOverlays.pda[whichSubPDA].line[renderLine].app > appsAtMasterLine then
					moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"], posX, getUpDownY(posY, vertical*(tempViewLines)));
					moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"]:render();									
					if not isHidden then 
						moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].x, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].x+moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].width, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].y+(moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].height/2), moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].y+moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].height, "lineLeft", renderLine, whichSubPDA);
						moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].x, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].x+moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].width, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].y, moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].y+(moSetGetOverlays.pda[whichSubPDA].design["lineLeftRight"].height/2), "lineRight", renderLine, whichSubPDA);
					end;
				end;
				--Setting Open Line
				if g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, whichSubPDA, true, true, nil) then--guiMenueSettings:isSelectPageGlobalName(self, whichSubPDA) then						
					local infoTxt = tostring(renderLine);
					local optiSize = moSetGetExtras:optiHeightSize(self, vertical, tostring(infoTxt), 0.009);
					moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["groundSetting"], posX+width-(horizontal/2), getUpDownY(posY, vertical*(tempViewLines))+(vertical/2), horizontal/2, vertical/2);
					moSetGetOverlays:setBackgroundColor(moSetGetOverlays.pda[whichSubPDA].design["groundSetting"], moColors.intern["mangenta"]);
					moSetGetOverlays.pda[whichSubPDA].design["groundSetting"]:render();
					moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"], posX+width-(horizontal/2), getUpDownY(posY, vertical*(tempViewLines))+(vertical/2), horizontal/2, vertical/2);
					selectSettingLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA);
					if tonumber(selectSettingLine) == tonumber(renderLine) then
						moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].x, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].x+moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].width, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].y, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].y+moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].height, "lineSetting", renderLine, whichSubPDA);
					end;					
					if tonumber(selectSettingLine) == tonumber(renderLine) and not moSetGetExtras:runsTimer("1sec", true) then						
						moSetGetOverlays.pda[whichSubPDA].design["otherSetting"]:render();
					else 
						local optiSize = moSetGetExtras:optiHeightSize(self, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].height, tostring(infoTxt), 0.009);
						setTextColor(unpack(moColors.intern["mangenta"]));
						setTextBold(true);						
						setTextAlignment(1);						
						renderText(moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].x+(moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].width/2.4), moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].y+0.002, optiSize, tostring(infoTxt));
						setTextAlignment(0);
						setTextBold(false);
						setTextColor(1, 1, 1, 1);
					end;
				end;
				--Setting open Line
			end;
			local foundMoneyIcon = 0;
			local lastMoneyIcon = false;
			local errorMoney = false;
			local viewAppIcon = 0;
			local appSelect = moSetGetOverlays.pda[whichSubPDA].line[renderLine].appSelect;
			if appSelect > 1 and moSetGetOverlays.pda[whichSubPDA].line[renderLine].appsAtLine <= appsAtMasterLine then appSelect = 1;end;			
			appSettingSelect = moSetGetOverlays.pda[whichSubPDA].appMouseSelect.app; --moSetGetOverlays.pda[whichSubPDA].line[renderLine].appSettingSelect;			
			for b=appSelect, moSetGetOverlays.pda[whichSubPDA].line[renderLine].appsAtLine do				
				if viewAppIcon <= appsAtMasterLine then
					viewAppIcon = viewAppIcon+1;
					--Setting Open Apps 
					if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp > 0 then						
						local iconName = moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconName;
						local iconTyp = moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp;
						if moSetGetOverlays.appIcon[whichSubPDA][iconName] == nil then 
							iconName = "mohIconFail_";iconTyp=1;
							if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].changeIcon == nil then moSetGetOverlays:changeAppIcon(self, whichSubPDA, renderLine, b);end;
						end;
						local renderOverlay = true;
						moSetGetOverlays:setOverlay(self, moSetGetOverlays.appIcon[whichSubPDA][iconName], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight);
						if not g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then
							if iconTyp == 5 and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp] ~= nil and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].category ~= nil and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].categoryTyp ~= nil then
								local category = moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].category;
								local categoryTyp = moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].categoryTyp;
								if category == "TIME" or category == "CLOCK" or category == "WEATHER" or category == "MONEY" or category == "SCALE" or category == "PLAYDAY" or category == "TEMPERATURE" then
									if (category == "CLOCK" or category == "WEATHER" or category == "TEMPERATURE") and moSetGetOverlays.foreignIcons["weatherTimeMoney"] ~= nil and #moSetGetOverlays.foreignIcons["weatherTimeMoney"] > 0 then
										lastMoneyIcon = false;
										if category == "CLOCK" and categoryTyp == 3 then
											local overlay = MultiOverlayV3.wtm.overlays.clockElement.overlay; --g_currentMission.hud.gameInfoDisplay.clockElement.overlay;
											local overlay1 = MultiOverlayV3.wtm.overlays.clockHandSmall.overlay; --g_currentMission.hud.gameInfoDisplay.clockHandSmall.overlay;
											local overlay2 = MultiOverlayV3.wtm.overlays.clockHandLarge.overlay; --g_currentMission.hud.gameInfoDisplay.clockHandLarge.overlay;													
											moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][1], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
											moSetGetOverlays.foreignIcons["weatherTimeMoney"][1]:render();																										
											moSetGetOverlays:setOverlay(self, MultiOverlayV3.wtm.overlays.clockElement.overlay, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
											--MultiOverlayV3.wtm.overlays.clockElement.overlay:render();											
											local middleWidth = moSetGetOverlays.appIcon[whichSubPDA][iconName].width/12;
											local middlePosX = moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2; --distanceAppIconWidth/2;
											local middlePosY = moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2; --distanceAppIconHeight/2;
											moSetGetExtras:setClock(MultiOverlayV3.wtm.overlays.clockHandSmall.overlay, MultiOverlayV3.wtm.overlays.clockHandLarge.overlay, 0, 0);
											moSetGetOverlays:setOverlay(self, MultiOverlayV3.wtm.overlays.clockHandSmall.overlay, middlePosX, middlePosY, middleWidth, moSetGetOverlays.foreignIcons["weatherTimeMoney"][1].height/3);
											MultiOverlayV3.wtm.overlays.clockHandSmall.overlay:render();
											moSetGetOverlays:setOverlay(self, MultiOverlayV3.wtm.overlays.clockHandLarge.overlay, middlePosX, middlePosY, middleWidth, moSetGetOverlays.foreignIcons["weatherTimeMoney"][1].height/2.1);
											MultiOverlayV3.wtm.overlays.clockHandLarge.overlay:render();
											renderOverlay = false;
										elseif category == "WEATHER" and (categoryTyp == 1 or categoryTyp == 2) then
											local isNight = moSetGetExtras:getDayNight();
											if not isNight then
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][12], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
												moSetGetOverlays.foreignIcons["weatherTimeMoney"][12]:render();
											else
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][13], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
												moSetGetOverlays.foreignIcons["weatherTimeMoney"][13]:render();
											end;
											local seasons, weatherTyp1, weatherTyp1_1, weatherTyp2, weatherTyp2_2 = moSetGetExtras:getCurrentAndNextWeather();
											function setWeatherTime(only)
												local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
												local dayTimeTimer, currentWeatherEnd, nextWeatherStart, nextWeatherEnd = moSetGetExtras:getWeatherDayTime();
												local txt = tostring(nextWeatherStart);
												local widthDif = 1;
												if only then 
													local wind = moSetGetExtras:getWindScale()
													widthDif = 2;
													txt = tostring(wind);
												end;
												local optiSizeHeight = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
												local optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/widthDif, tostring(txt), optiSizeHeight);
												setTextColor(unpack(moColors.intern["black"]));
												if isNight then setTextColor(unpack(moColors.intern["white"]));end;
												setTextBold(true);
												setTextAlignment(1);
												if only then
													local txtWidth = getTextWidth(optiSize, tostring(txt));
													setTextAlignment(0);
													renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width)-txtWidth, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize-0.001, tostring(txt));
												else
													renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize, tostring(txt));
												end;
												setTextAlignment(0);													
												setTextColor(1, 1, 1, 1);
												setTextBold(false);
											end;												
											if categoryTyp == 1 or (categoryTyp == 2 and weatherTyp1_1 ~= weatherTyp2_2) then														
												if (categoryTyp == 2 and weatherTyp1_1 ~= weatherTyp2_2) then weatherTyp1=weatherTyp2;weatherTyp1_1=weatherTyp2_2;end;
												--moSetGetExtras:getFogScale()												
												local cloudScale = moSetGetExtras:getCloudScale(seasons);																	
												if weatherTyp1 == 2 then													
													if not isNight then
														moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][2], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
														moSetGetOverlays.foreignIcons["weatherTimeMoney"][2]:render();
													else
														moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][11], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
														moSetGetOverlays.foreignIcons["weatherTimeMoney"][11]:render();
													end;													
													if categoryTyp == 1 then
														if (cloudScale > 1.0 and cloudScale < 3.4) then
															moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][10], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
															moSetGetOverlays.foreignIcons["weatherTimeMoney"][10]:render();
														elseif cloudScale >= 3.4 then
															moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][3], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
															moSetGetOverlays.foreignIcons["weatherTimeMoney"][3]:render();
														end;
													elseif categoryTyp == 2 and seasons and weatherTyp2_2 == 3 then
														moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][3], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
														moSetGetOverlays.foreignIcons["weatherTimeMoney"][3]:render();
													end;
													renderOverlay = false;												
												else 
													moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][3], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
													moSetGetOverlays.foreignIcons["weatherTimeMoney"][3]:render();
													renderOverlay = false;
												end; 
												if weatherTyp1 == 3 and weatherTyp1_1 ~= 3 then --or (cloudScale >= 6.2 and categoryTyp == 1) then
													moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][weatherTyp1_1], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
													if not seasons then
														if MultiOverlayV3.timers["updateWeather"] == nil then
															moSetGetExtras:addTimer( {delay=10, name="updateWeather", repeatable=6, ms=false, action=nil} );
														end;													
														local isTimer, isRepeatable = moSetGetExtras:runsTimer("updateWeather");
														if (isTimer == nil or categoryTyp == 1) or (isTimer ~= nil and isRepeatable ~= 3 and categoryTyp == 2) then
															moSetGetOverlays.foreignIcons["weatherTimeMoney"][weatherTyp1_1]:render();
														elseif isTimer ~= nil and isRepeatable == 3 and categoryTyp == 2 then
															setWeatherTime(false);														
														end;
													else
														moSetGetOverlays.foreignIcons["weatherTimeMoney"][weatherTyp1_1]:render();
													end;
												end;												
											elseif categoryTyp == 2 and weatherTyp1_1 == weatherTyp2_2 then
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][15], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
												moSetGetOverlays.foreignIcons["weatherTimeMoney"][15]:render();
												setWeatherTime(true);
												renderOverlay = false;
											end;
										elseif category == "TEMPERATURE" and categoryTyp == 12 then										
											moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][14], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
											moSetGetOverlays.foreignIcons["weatherTimeMoney"][14]:render();	
											moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][16], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
											local trend, isTemp, dayTemp, nightTemp = moSetGetExtras:getTemperature();											
											local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
											local optiSizeHeight = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring("-30"), 0.015);
											local optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2, tostring("-30"), optiSizeHeight);
											local txtWidth = getTextWidth(optiSize, "-30");
											local txtHeight = getTextHeight(optiSize, "-30")
											moSetGetOverlays:setBackgroundColor(moSetGetOverlays.foreignIcons["weatherTimeMoney"][16], moColors.intern["red"])
											if isTemp == nil and ((isNight and string.find(nightTemp, "-")) or (not isNight and string.find(dayTemp, "-"))) then moSetGetOverlays:setBackgroundColor(moSetGetOverlays.foreignIcons["weatherTimeMoney"][16], moColors.intern["darkBlue"]);
											else
												if isTemp < 0 then moSetGetOverlays:setBackgroundColor(moSetGetOverlays.foreignIcons["weatherTimeMoney"][16], moColors.intern["darkBlue"]);end;
											end;
											moSetGetOverlays.foreignIcons["weatherTimeMoney"][16]:render();
											setTextColor(unpack(moColors.intern["black"]));
											setTextBold(true);
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width)-(txtWidth), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt+(iconHeigt/2))-(txtHeight/2)+verticalTxtDistance, optiSize, tostring(dayTemp));
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width)-(txtWidth), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt/2)-(txtHeight/2)+verticalTxtDistance, optiSize, tostring(nightTemp));
											setTextColor(1, 1, 1, 1);
											setTextBold(false);
											renderOverlay = false;
										end;
									elseif category == "SCALE" and categoryTyp == 8 then
										lastMoneyIcon = false;
										local timeScale = Utils.getNoNil(g_currentMission.missionInfo.timeScale, 1);
										local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
										local txt = ">"
										if timeScale > 120 then txt = ">>>";elseif timeScale > 1 then txt = ">>";end;
										local optiSizeHeight = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
										local optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSizeHeight);
										if timeScale > 1 then setTextColor(unpack(moColors.intern["red"]));else setTextColor(unpack(moColors.intern["black"]));end;
										setTextBold(true);
										setTextAlignment(1);
										renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt)+verticalTxtDistance, optiSize, tostring(txt));
										txt = tostring(timeScale);
										optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSizeHeight);
										renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize, tostring(txt));
										setTextAlignment(0);													
										setTextColor(1, 1, 1, 1);
										setTextBold(false);
										renderOverlay = false;
									elseif category == "PLAYDAY" and categoryTyp == 7 then
										lastMoneyIcon = false;
										local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
										local gameDay, weekDay = moSetGetExtras:getInGameDay(true, true);
										local txt = moLanguageXml:getTxt("day", nil, "Day");
										local optiSizeHeight = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
										local optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSizeHeight);
										setTextColor(unpack(moColors.intern["black"]));
										setTextBold(true);
										setTextAlignment(1);
										renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt)+verticalTxtDistance, optiSize, tostring(txt));
										renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize, tostring(gameDay));
										setTextAlignment(0);													
										setTextColor(1, 1, 1, 1);
										setTextBold(false);
										renderOverlay = false;
									elseif category == "MONEY" and g_currentMission.player ~= nil and categoryTyp >= 9 and categoryTyp <= 11 then
										if foundMoneyIcon > 0 and not lastMoneyIcon then errorMoney=true;end;
										if not errorMoney then foundMoneyIcon=foundMoneyIcon+1;lastMoneyIcon=true;end;
										if categoryTyp == 11 then
											if foundMoneyIcon ~= 3 then errorMoney=true;end;
											local farm = g_farmManager:getFarmById(g_currentMission.player.farmId);
											local moneyUnit = g_i18n:getCurrencySymbol(true);											
											local txt = "Error";
											local heightDif = 3;
											if not errorMoney then txt=g_i18n:formatMoney(farm.money, 0, true, true);heightDif=1;end;											
											--if not errorMoney then txt="€ 999.999.999";heightDif=1;end;
											local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/heightDif;
											local optiSizeHeight = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.020);
											local optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width*3+(distanceAppIconWidth*2), tostring("€ 999.999.999"), optiSizeHeight)+0.001;
											local txtHeight = getTextHeight(optiSize, tostring(txt));
											local txtWidth = getTextWidth(optiSize, tostring(txt)); 
											setTextColor(unpack(moColors.intern["darkGreen"]));
											if Utils.getNoNil(farm.money, 0) < 0 or errorMoney then setTextColor(unpack(moColors.intern["red"]));end;
											setTextBold(true);											
											if not errorMoney then
												renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width)-txtWidth-horizontalTxtDistance, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2)+verticalTxtDistance-(txtHeight/2), optiSize, tostring(txt));
											else
												setTextAlignment(1);
												renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt*2)+verticalTxtDistance, optiSize-0.001, tostring(txt));
												renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt)+verticalTxtDistance, optiSize-0.001, tostring("needs"));
												renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize-0.0015, tostring("3xIcon"));
											end;
											setTextAlignment(0);													
											setTextColor(1, 1, 1, 1);
											setTextBold(false);											
										end;
										renderOverlay = false;
									elseif category == "TIME" then	
										lastMoneyIcon = false;
										setTextColor(unpack(moColors.intern["black"]));
										setTextBold(true);
										setTextAlignment(1);
										if categoryTyp == 4 then --GameTime,PLAYDAY
											local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/3;
											local txt = moSetGetExtras:getMilliSecondsToHours(g_currentMission.environment.dayTime, true);
											local optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
											optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt*2)+verticalTxtDistance, optiSize, tostring(txt));
											txt = moLanguageXml:getTxt("day", nil, "Day");
											optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
											optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt)+verticalTxtDistance, optiSize, tostring(txt));
											local gameDay, weekDay = moSetGetExtras:getInGameDay(true, true);
											txt = tostring(gameDay);
											optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
											optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize, tostring(txt));
										elseif categoryTyp == 5 then --GameTime
											local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
											local txt = moSetGetExtras:getMilliSecondsToHours(g_currentMission.environment.dayTime, true);
											local optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
											optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
											local txtHeight = getTextHeight(optiSize, tostring(txt));
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt)+verticalTxtDistance-(txtHeight/2), optiSize, tostring(txt));
										elseif categoryTyp == 6 then --RealTime
											local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
											local realWeekDay = moSetGetExtras:getRealDay(false, true, false, false);
											if tonumber(realWeekDay) == 0 then realWeekDay = 7;end;													
											local txt = moLanguageXml:getTxt("day"..tostring(realWeekDay), 5);
											local optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
											optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
											setTextColor(unpack(moColors.intern["darkBlue"]));
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt)+verticalTxtDistance, optiSize, tostring(txt));
											txt = moSetGetExtras:getRealTime(true, true, false);
											optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
											optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize, tostring(txt));
										end;
										setTextAlignment(0);													
										setTextColor(1, 1, 1, 1);
										setTextBold(false);
										renderOverlay = false;										
									end;
								elseif category == "DIGICLOCK" then
									local digiClockIcons = moSetGetExtras:getDigiClock(g_currentMission.environment.dayTime, true, true, true);
									if digiClockIcons ~= nil then										
										moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][1], moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
										moSetGetOverlays.foreignIcons["digiClock"][1]:render();
										--13 hours,14 minutes
										if categoryTyp == 13 then											
											for _, icon in pairs(digiClockIcons.hours[1]) do
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][icon], moSetGetOverlays.foreignIcons["digiClock"][1].x, moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
												moSetGetOverlays.foreignIcons["digiClock"][icon]:render();
											end;
											for _, icon in pairs(digiClockIcons.hours[2]) do
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][icon], moSetGetOverlays.foreignIcons["digiClock"][1].x, moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
												moSetGetOverlays.foreignIcons["digiClock"][icon]:render();
											end;
										end;										
										if categoryTyp == 14 then
											moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][2], moSetGetOverlays.foreignIcons["digiClock"][1].x-(moSetGetOverlays.foreignIcons["digiClock"][1].width/2)-(distanceAppIconWidth/2), moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
											moSetGetOverlays.foreignIcons["digiClock"][2]:render();
											for _, icon in pairs(digiClockIcons.minutes[1]) do
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][icon], moSetGetOverlays.foreignIcons["digiClock"][1].x, moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
												moSetGetOverlays.foreignIcons["digiClock"][icon]:render();
											end;
											for _, icon in pairs(digiClockIcons.minutes[2]) do
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][icon], moSetGetOverlays.foreignIcons["digiClock"][1].x, moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
												moSetGetOverlays.foreignIcons["digiClock"][icon]:render();
											end;
										end;
										if categoryTyp == 15 then
											moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][2], moSetGetOverlays.foreignIcons["digiClock"][1].x-(moSetGetOverlays.foreignIcons["digiClock"][1].width/2)-(distanceAppIconWidth/2), moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
											moSetGetOverlays.foreignIcons["digiClock"][2]:render();
											for _, icon in pairs(digiClockIcons.seconds[1]) do
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][icon], moSetGetOverlays.foreignIcons["digiClock"][1].x, moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
												moSetGetOverlays.foreignIcons["digiClock"][icon]:render();
											end;
											for _, icon in pairs(digiClockIcons.seconds[2]) do
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][icon], moSetGetOverlays.foreignIcons["digiClock"][1].x, moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
												moSetGetOverlays.foreignIcons["digiClock"][icon]:render();
											end;
										end;
									end;
									renderOverlay = false;
								elseif category == "SEASONS" then
									lastMoneyIcon = false;
									if MultiOverlayV3.otherMods.seasons == nil or g_seasons == nil then
										local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
										local txt = "Seasons"
										local optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
										optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
										setTextColor(unpack(moColors.intern["red"]));
										setTextAlignment(1);
										setTextBold(true);
										renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt)+verticalTxtDistance, optiSize, tostring("needs"));
										renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize, tostring(txt));
										setTextAlignment(0);													
										setTextColor(1, 1, 1, 1);
										setTextBold(false);
										renderOverlay = false;
									else
										if categoryTyp >= 1 and categoryTyp <= 4 then
											local currentSeason = g_seasons.weather.environment.season;
											local currentPeriod = g_seasons.weather.environment.period;
											local s1, s2 = 0,0;
											if categoryTyp == 1 then s1,s2=1,4;elseif categoryTyp == 2 then s1,s2=5,8;elseif categoryTyp == 3 then s1,s2=9,12;elseif categoryTyp == 4 then s1,s2=13,16;end;										
											if currentSeason <= 4 then
												local seasonStyleIcon = s1+currentSeason;											
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["seasons"][seasonStyleIcon], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
												moSetGetOverlays.foreignIcons["seasons"][seasonStyleIcon]:render();
												local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
												local optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
												optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
												setTextColor(unpack(moColors.intern["black"]));
												local txtWidth = getTextWidth(optiSize, tostring(currentPeriod)); -- +2 for month 1-12; + 2 NorthContigent, +6 SouthContigent (later over Settings)
												if categoryTyp == 1 and currentSeason > 1 then setTextColor(unpack(moColors.intern["white"]));end;
												if categoryTyp == 4 then setTextColor(unpack(moColors.intern["red"]));end;
												setTextBold(true);
												renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width-(txtWidth), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize, tostring(currentPeriod));
												setTextColor(1, 1, 1, 1);
												setTextBold(false);
											else
												--! season error !
											end;
											renderOverlay = false;
										elseif categoryTyp == 5 or categoryTyp == 6 then	
											local mOn, cropsMoisture = moSetGetExtras:isCropMoisture();
											local fOn, cropsFrozen = moSetGetExtras:isCropFrozen();
											if cropsFrozen or cropsMoisture then
												if categoryTyp == 6 then
													moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["seasonsOther"][3], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
													moSetGetOverlays.foreignIcons["seasonsOther"][3]:render();
													if cropsFrozen then
														moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["seasonsOther"][4], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
														moSetGetOverlays.foreignIcons["seasonsOther"][4]:render();
													elseif cropsMoisture then
														moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["seasonsOther"][5], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
														moSetGetOverlays.foreignIcons["seasonsOther"][5]:render();
													end;
												elseif categoryTyp == 5 then
													if cropsFrozen then
														moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["seasonsOther"][6], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
														moSetGetOverlays.foreignIcons["seasonsOther"][6]:render();
													elseif cropsMoisture then
														moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["seasonsOther"][7], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
														moSetGetOverlays.foreignIcons["seasonsOther"][7]:render();
													end;													
												end;
											else
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["seasonsOther"][1], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
												moSetGetOverlays.foreignIcons["seasonsOther"][1]:render();
											end;
											renderOverlay = false;
										elseif categoryTyp == 7 or categoryTyp == 8 then
											local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
											local soilTemp = moSetGetExtras:getSoilTemperature();
											local txt = soilTemp;
											local optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring("-30 °C"), 0.015);
											optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring("-30 °C"), optiSize);
											local txtHeight = getTextHeight(optiSize-0.001, tostring("-30 °C"));
											setTextColor(unpack(moColors.intern["black"]));
											setTextBold(true);
											setTextAlignment(1);
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(moSetGetOverlays.appIcon[whichSubPDA][iconName].height)-txtHeight, optiSize-0.001, tostring(txt));
											setTextAlignment(0);
											setTextColor(1, 1, 1, 1);
											setTextBold(false);											
										end;
									end;									
								end;
							end;
						end;						
						if renderOverlay then
							moSetGetOverlays.appIcon[whichSubPDA][iconName]:render();
						end;
						if g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then
							moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickOpenSetting", renderLine, whichSubPDA, b, iconName);
						else
							moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickNormal", renderLine, whichSubPDA, b, iconName);
						end;
						if iconTyp == 3 and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp] ~= nil and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color ~= nil then
							if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color[3] then
								moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[whichSubPDA][iconName], moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color[1]);
							else
								moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[whichSubPDA][iconName], moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color[2]);
							end;
						elseif iconTyp == 4 and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp] ~= nil and string.len(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].txt) > 0 then
							setTextColor(unpack(moColors.intern["black"]));
							if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].color ~= nil then setTextColor(unpack(moColors:getColor(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].color, nil, {0,0,0,1})));end;
							--moColors:getColor(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].color, nil, {0,0,0,1})
							local iconTxt = tostring(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].txt);
							local optiSize = moSetGetExtras:optiHeightSize(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2-(verticalTxtDistance), tostring(iconTxt), 0.015);
							if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].size ~= nil then
								if optiSize > moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].size then optiSize = moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].size;end;
							end;
							if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].bold ~= nil then
								setTextBold(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].bold);
							end;
							--local txtHeight = getTextHeight(optiSize, tostring(iconTxt));
							setTextWrapWidth(moSetGetOverlays.appIcon[whichSubPDA][iconName].width-(horizontalTxtDistance));
							setTextLineBounds(0, 2);
							setTextAlignment(1);
							renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2)+verticalTxtDistance, optiSize, tostring(iconTxt))
							setTextAlignment(0);
							setTextWrapWidth(0);
							setTextLineBounds(0, 0);
							setTextColor(1, 1, 1, 1);
							setTextBold(false);
						end;
						if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].openMarker ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].openMarker then
							moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["openMarker"], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth+(horizontal-moSetGetOverlays.pda[whichSubPDA].design["openMarker"].width-distanceAppIconWidth), getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight);
							moSetGetOverlays.pda[whichSubPDA].design["openMarker"]:render();
						end;						
					end;
					if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp == 0 then
						local iconName = "mohIconBlank_";
						moSetGetOverlays:setOverlay(self, moSetGetOverlays.appIcon[whichSubPDA][iconName], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight);
						moSetGetOverlays.appIcon[whichSubPDA][iconName]:render();
						if g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then
							moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickOpenSetting", renderLine, whichSubPDA, b, iconName);
						else
							moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickNormal", renderLine, whichSubPDA, b, iconName);
						end;
					end;
					if g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, whichSubPDA, true, true, nil) then --guiMenueSettings:isSelectPageGlobalName(self, whichSubPDA) then
						moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth-(horizontal/2), getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, horizontal/2.5, vertical/2.5);
						moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["groundSetting"], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth-(horizontal/2), getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, horizontal/2.5, vertical/2.5);
						moSetGetOverlays:setBackgroundColor(moSetGetOverlays.pda[whichSubPDA].design["groundSetting"], moColors.intern["mangenta"]);						
						if tonumber(appSettingSelect) == tonumber(b) and tonumber(selectSettingLine) == tonumber(renderLine) then
							moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[11], newPosX+(horizontal*(viewAppIcon-1)), getUpDownY(posY, vertical*tempViewLines));
							moSetGetOverlays.pda[whichSubPDA].design[11]:render();
							--moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design[11].x, moSetGetOverlays.pda[whichSubPDA].design[11].x+moSetGetOverlays.pda[whichSubPDA].design[11].width, moSetGetOverlays.pda[whichSubPDA].design[11].y, moSetGetOverlays.pda[whichSubPDA].design[11].y+moSetGetOverlays.pda[whichSubPDA].design[11].height, "appSetting", renderLine, whichSubPDA, b);
						end;
						if not moSetGetExtras:runsTimer("3sec", true) and tonumber(selectSettingLine) == tonumber(renderLine) then
							moSetGetOverlays.pda[whichSubPDA].design["groundSetting"]:render();
							if tonumber(appSettingSelect) == tonumber(b) and not moSetGetExtras:runsTimer("1sec", true) then
								moSetGetOverlays.pda[whichSubPDA].design["otherSetting"]:render();
							else
								local infoTxt = tostring(b);
								local optiSize = moSetGetExtras:optiHeightSize(self, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].height, tostring(infoTxt), 0.009);
								setTextColor(unpack(moColors.intern["mangenta"]));
								setTextBold(true);						
								setTextAlignment(1);								
								renderText(moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].x+(moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].width/2.4), moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].y+0.002, optiSize, tostring(infoTxt));
								setTextAlignment(0);
								setTextBold(false);
								setTextColor(1, 1, 1, 1);
							end;
						end;
					end;
					--Setting Open Apps
					if viewAppIcon >= appsAtMasterLine then break;end;
					--test
						
					--test
				end;
			end;
			if viewAppIcon < appsAtMasterLine and viewAppIcon < moSetGetOverlays.pda[whichSubPDA].line[renderLine].appsAtLine then
				for b=1, moSetGetOverlays.pda[whichSubPDA].line[renderLine].appsAtLine do					
					if viewAppIcon <= appsAtMasterLine then	
						--Setting Open Apps.						
						if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp > 0 then						
							local iconName = moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconName;
							local iconTyp = moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp;
							if moSetGetOverlays.appIcon[whichSubPDA][iconName] == nil then 
								iconName = "mohIconFail_";iconTyp=1;
								if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].changeIcon == nil then moSetGetOverlays:changeAppIcon(self, whichSubPDA, renderLine, b);end;
							end;
							local renderOverlay = true;
							moSetGetOverlays:setOverlay(self, moSetGetOverlays.appIcon[whichSubPDA][iconName], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight);
							if not g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then
								if iconTyp == 5 and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp] ~= nil and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].category ~= nil and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].categoryTyp ~= nil then
									local category = moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].category;
									local categoryTyp = moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].categoryTyp;
									if category == "TIME" or category == "CLOCK" or category == "WEATHER" or category == "MONEY" or category == "SCALE" or category == "PLAYDAY" or category == "TEMPERATURE" then
										if (category == "CLOCK" or category == "WEATHER" or category == "TEMPERATURE") and moSetGetOverlays.foreignIcons["weatherTimeMoney"] ~= nil and #moSetGetOverlays.foreignIcons["weatherTimeMoney"] > 0 then
											lastMoneyIcon = false;
											if category == "CLOCK" and categoryTyp == 3 then
												local overlay = MultiOverlayV3.wtm.overlays.clockElement.overlay; --g_currentMission.hud.gameInfoDisplay.clockElement.overlay;
												local overlay1 = MultiOverlayV3.wtm.overlays.clockHandSmall.overlay; --g_currentMission.hud.gameInfoDisplay.clockHandSmall.overlay;
												local overlay2 = MultiOverlayV3.wtm.overlays.clockHandLarge.overlay; --g_currentMission.hud.gameInfoDisplay.clockHandLarge.overlay;													
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][1], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
												moSetGetOverlays.foreignIcons["weatherTimeMoney"][1]:render();																										
												moSetGetOverlays:setOverlay(self, MultiOverlayV3.wtm.overlays.clockElement.overlay, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
												--MultiOverlayV3.wtm.overlays.clockElement.overlay:render();											
												local middleWidth = moSetGetOverlays.appIcon[whichSubPDA][iconName].width/12;
												local middlePosX = moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2; --distanceAppIconWidth/2;
												local middlePosY = moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2; --distanceAppIconHeight/2;
												moSetGetExtras:setClock(MultiOverlayV3.wtm.overlays.clockHandSmall.overlay, MultiOverlayV3.wtm.overlays.clockHandLarge.overlay, 0, 0);
												moSetGetOverlays:setOverlay(self, MultiOverlayV3.wtm.overlays.clockHandSmall.overlay, middlePosX, middlePosY, middleWidth, moSetGetOverlays.foreignIcons["weatherTimeMoney"][1].height/3);
												MultiOverlayV3.wtm.overlays.clockHandSmall.overlay:render();
												moSetGetOverlays:setOverlay(self, MultiOverlayV3.wtm.overlays.clockHandLarge.overlay, middlePosX, middlePosY, middleWidth, moSetGetOverlays.foreignIcons["weatherTimeMoney"][1].height/2.1);
												MultiOverlayV3.wtm.overlays.clockHandLarge.overlay:render();
												renderOverlay = false;
											elseif category == "WEATHER" and (categoryTyp == 1 or categoryTyp == 2) then
												local isNight = moSetGetExtras:getDayNight();
												if not isNight then
													moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][12], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
													moSetGetOverlays.foreignIcons["weatherTimeMoney"][12]:render();
												else
													moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][13], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
													moSetGetOverlays.foreignIcons["weatherTimeMoney"][13]:render();
												end;
												local seasons, weatherTyp1, weatherTyp1_1, weatherTyp2, weatherTyp2_2 = moSetGetExtras:getCurrentAndNextWeather();
												function setWeatherTime(only)
													local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
													local dayTimeTimer, currentWeatherEnd, nextWeatherStart, nextWeatherEnd = moSetGetExtras:getWeatherDayTime();
													local txt = tostring(nextWeatherStart);
													local widthDif = 1;
													if only then 
														local wind = moSetGetExtras:getWindScale()
														widthDif = 2;
														txt = tostring(wind);
													end;
													local optiSizeHeight = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
													local optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/widthDif, tostring(txt), optiSizeHeight);
													setTextColor(unpack(moColors.intern["black"]));
													if isNight then setTextColor(unpack(moColors.intern["white"]));end;
													setTextBold(true);
													setTextAlignment(1);
													if only then
														local txtWidth = getTextWidth(optiSize, tostring(txt));
														setTextAlignment(0);
														renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width)-txtWidth, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize-0.001, tostring(txt));
													else
														renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize, tostring(txt));
													end;
													setTextAlignment(0);													
													setTextColor(1, 1, 1, 1);
													setTextBold(false);
												end;												
												if categoryTyp == 1 or (categoryTyp == 2 and weatherTyp1_1 ~= weatherTyp2_2) then														
													if (categoryTyp == 2 and weatherTyp1_1 ~= weatherTyp2_2) then weatherTyp1=weatherTyp2;weatherTyp1_1=weatherTyp2_2;end;
													--moSetGetExtras:getFogScale()												
													local cloudScale = moSetGetExtras:getCloudScale(seasons);																	
													if weatherTyp1 == 2 then													
														if not isNight then
															moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][2], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
															moSetGetOverlays.foreignIcons["weatherTimeMoney"][2]:render();
														else
															moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][11], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
															moSetGetOverlays.foreignIcons["weatherTimeMoney"][11]:render();
														end;													
														if categoryTyp == 1 then
															if (cloudScale > 1.0 and cloudScale < 3.4) then
																moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][10], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
																moSetGetOverlays.foreignIcons["weatherTimeMoney"][10]:render();
															elseif cloudScale >= 3.4 then
																moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][3], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
																moSetGetOverlays.foreignIcons["weatherTimeMoney"][3]:render();
															end;
														elseif categoryTyp == 2 and seasons and weatherTyp2_2 == 3 then
															moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][3], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
															moSetGetOverlays.foreignIcons["weatherTimeMoney"][3]:render();
														end;
														renderOverlay = false;												
													else 
														moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][3], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
														moSetGetOverlays.foreignIcons["weatherTimeMoney"][3]:render();
														renderOverlay = false;
													end; 
													if weatherTyp1 == 3 and weatherTyp1_1 ~= 3 then ---or (cloudScale >= 6.2 and categoryTyp == 1) then
														moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][weatherTyp1_1], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
														if not seasons then
															if MultiOverlayV3.timers["updateWeather"] == nil then
																moSetGetExtras:addTimer( {delay=10, name="updateWeather", repeatable=6, ms=false, action=nil} );
															end;													
															local isTimer, isRepeatable = moSetGetExtras:runsTimer("updateWeather");
															if (isTimer == nil or categoryTyp == 1) or (isTimer ~= nil and isRepeatable ~= 3 and categoryTyp == 2) then
																moSetGetOverlays.foreignIcons["weatherTimeMoney"][weatherTyp1_1]:render();
															elseif isTimer ~= nil and isRepeatable == 3 and categoryTyp == 2 then
																setWeatherTime(false);														
															end;
														else
															moSetGetOverlays.foreignIcons["weatherTimeMoney"][weatherTyp1_1]:render();
														end;														
													end;													
												elseif categoryTyp == 2 and weatherTyp1_1 == weatherTyp2_2 then
													moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][15], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
													moSetGetOverlays.foreignIcons["weatherTimeMoney"][15]:render();
													setWeatherTime(true);
													renderOverlay = false;
												end;												
											elseif category == "TEMPERATURE" and categoryTyp == 12 then										
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][14], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
												moSetGetOverlays.foreignIcons["weatherTimeMoney"][14]:render();	
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["weatherTimeMoney"][16], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
												local trend, isTemp, dayTemp, nightTemp = moSetGetExtras:getTemperature();											
												local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
												local optiSizeHeight = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring("-30"), 0.015);
												local optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2, tostring("-30"), optiSizeHeight);
												local txtWidth = getTextWidth(optiSize, "-30");
												local txtHeight = getTextHeight(optiSize, "-30")
												moSetGetOverlays:setBackgroundColor(moSetGetOverlays.foreignIcons["weatherTimeMoney"][16], moColors.intern["red"])
												if isTemp == nil and ((isNight and string.find(nightTemp, "-")) or (not isNight and string.find(dayTemp, "-"))) then moSetGetOverlays:setBackgroundColor(moSetGetOverlays.foreignIcons["weatherTimeMoney"][16], moColors.intern["darkBlue"]);
												else
													if isTemp < 0 then moSetGetOverlays:setBackgroundColor(moSetGetOverlays.foreignIcons["weatherTimeMoney"][16], moColors.intern["darkBlue"]);end;
												end;
												moSetGetOverlays.foreignIcons["weatherTimeMoney"][16]:render();
												setTextColor(unpack(moColors.intern["black"]));
												setTextBold(true);
												renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width)-(txtWidth), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt+(iconHeigt/2))-(txtHeight/2)+verticalTxtDistance, optiSize, tostring(dayTemp));
												renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width)-(txtWidth), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt/2)-(txtHeight/2)+verticalTxtDistance, optiSize, tostring(nightTemp));
												setTextColor(1, 1, 1, 1);
												setTextBold(false);
												renderOverlay = false;
											end;
										elseif category == "SCALE" and categoryTyp == 8 then
											lastMoneyIcon = false;
											local timeScale = Utils.getNoNil(g_currentMission.missionInfo.timeScale, 1);
											local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
											local txt = ">"
											if timeScale > 120 then txt = ">>>";elseif timeScale > 1 then txt = ">>";end;
											local optiSizeHeight = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
											local optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSizeHeight);
											if timeScale > 1 then setTextColor(unpack(moColors.intern["red"]));else setTextColor(unpack(moColors.intern["black"]));end;
											setTextBold(true);
											setTextAlignment(1);
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt)+verticalTxtDistance, optiSize, tostring(txt));
											txt = tostring(timeScale);
											optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSizeHeight);
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize, tostring(txt));
											setTextAlignment(0);													
											setTextColor(1, 1, 1, 1);
											setTextBold(false);
											renderOverlay = false;
										elseif category == "PLAYDAY" and categoryTyp == 7 then
											lastMoneyIcon = false;
											local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
											local gameDay, weekDay = moSetGetExtras:getInGameDay(true, true);
											local txt = moLanguageXml:getTxt("day", nil, "Day");
											local optiSizeHeight = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
											local optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSizeHeight);
											setTextColor(unpack(moColors.intern["black"]));
											setTextBold(true);
											setTextAlignment(1);
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt)+verticalTxtDistance, optiSize, tostring(txt));
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize, tostring(gameDay));
											setTextAlignment(0);													
											setTextColor(1, 1, 1, 1);
											setTextBold(false);
											renderOverlay = false;
										elseif category == "MONEY" and g_currentMission.player ~= nil and categoryTyp >= 9 and categoryTyp <= 11 then
											if foundMoneyIcon > 0 and not lastMoneyIcon then errorMoney=true;end;
											if not errorMoney then foundMoneyIcon=foundMoneyIcon+1;lastMoneyIcon=true;end;
											if categoryTyp == 11 then
												if foundMoneyIcon ~= 3 then errorMoney=true;end;
												local farm = g_farmManager:getFarmById(g_currentMission.player.farmId);
												local moneyUnit = g_i18n:getCurrencySymbol(true);											
												local txt = "Error";
												local heightDif = 3;
												if not errorMoney then txt=g_i18n:formatMoney(farm.money, 0, true, true);heightDif=1;end;											
												--if not errorMoney then txt="€ 999.999.999";heightDif=1;end;
												local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/heightDif;
												local optiSizeHeight = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.020);
												local optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width*3+(distanceAppIconWidth*2), tostring("€ 999.999.999"), optiSizeHeight)+0.001;
												local txtHeight = getTextHeight(optiSize, tostring(txt));
												local txtWidth = getTextWidth(optiSize, tostring(txt)); 
												setTextColor(unpack(moColors.intern["darkGreen"]));
												if Utils.getNoNil(farm.money, 0) < 0 or errorMoney then setTextColor(unpack(moColors.intern["red"]));end;
												setTextBold(true);											
												if not errorMoney then
													renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width)-txtWidth-horizontalTxtDistance, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2)+verticalTxtDistance-(txtHeight/2), optiSize, tostring(txt));
												else
													setTextAlignment(1);
													renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt*2)+verticalTxtDistance, optiSize-0.001, tostring(txt));
													renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt)+verticalTxtDistance, optiSize-0.001, tostring("needs"));
													renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize-0.0015, tostring("3xIcon"));
												end;
												setTextAlignment(0);													
												setTextColor(1, 1, 1, 1);
												setTextBold(false);											
											end;
											renderOverlay = false;
										elseif category == "TIME" then	
											lastMoneyIcon = false;
											setTextColor(unpack(moColors.intern["black"]));
											setTextBold(true);
											setTextAlignment(1);
											if categoryTyp == 4 then --GameTime,PLAYDAY
												local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/3;
												local txt = moSetGetExtras:getMilliSecondsToHours(g_currentMission.environment.dayTime, true);
												local optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
												optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
												renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt*2)+verticalTxtDistance, optiSize, tostring(txt));
												txt = moLanguageXml:getTxt("day", nil, "Day");
												optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
												optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
												renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt)+verticalTxtDistance, optiSize, tostring(txt));
												local gameDay, weekDay = moSetGetExtras:getInGameDay(true, true);
												txt = tostring(gameDay);
												optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
												optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
												renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize, tostring(txt));
											elseif categoryTyp == 5 then --GameTime
												local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
												local txt = moSetGetExtras:getMilliSecondsToHours(g_currentMission.environment.dayTime, true);
												local optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
												optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
												local txtHeight = getTextHeight(optiSize, tostring(txt));
												renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt)+verticalTxtDistance-(txtHeight/2), optiSize, tostring(txt));
											elseif categoryTyp == 6 then --RealTime
												local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
												local realWeekDay = moSetGetExtras:getRealDay(false, true, false, false);
												if tonumber(realWeekDay) == 0 then realWeekDay = 7;end;													
												local txt = moLanguageXml:getTxt("day"..tostring(realWeekDay), 5);
												local optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
												optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
												setTextColor(unpack(moColors.intern["darkBlue"]));
												renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt)+verticalTxtDistance, optiSize, tostring(txt));
												txt = moSetGetExtras:getRealTime(true, true, false);
												optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
												optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
												renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize, tostring(txt));
											end;
											setTextAlignment(0);													
											setTextColor(1, 1, 1, 1);
											setTextBold(false);
											renderOverlay = false;										
										end;
									elseif category == "DIGICLOCK" then
										local digiClockIcons = moSetGetExtras:getDigiClock(g_currentMission.environment.dayTime, true, true, true);
										if digiClockIcons ~= nil then										
											moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][1], moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
											moSetGetOverlays.foreignIcons["digiClock"][1]:render();
											--13 hours,14 minutes
											if categoryTyp == 13 then											
												for _, icon in pairs(digiClockIcons.hours[1]) do
													moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][icon], moSetGetOverlays.foreignIcons["digiClock"][1].x, moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
													moSetGetOverlays.foreignIcons["digiClock"][icon]:render();
												end;
												for _, icon in pairs(digiClockIcons.hours[2]) do
													moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][icon], moSetGetOverlays.foreignIcons["digiClock"][1].x, moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
													moSetGetOverlays.foreignIcons["digiClock"][icon]:render();
												end;
											end;										
											if categoryTyp == 14 then
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][2], moSetGetOverlays.foreignIcons["digiClock"][1].x-(moSetGetOverlays.foreignIcons["digiClock"][1].width/2)-(distanceAppIconWidth/2), moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
												moSetGetOverlays.foreignIcons["digiClock"][2]:render();
												for _, icon in pairs(digiClockIcons.minutes[1]) do
													moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][icon], moSetGetOverlays.foreignIcons["digiClock"][1].x, moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
													moSetGetOverlays.foreignIcons["digiClock"][icon]:render();
												end;
												for _, icon in pairs(digiClockIcons.minutes[2]) do
													moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][icon], moSetGetOverlays.foreignIcons["digiClock"][1].x, moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
													moSetGetOverlays.foreignIcons["digiClock"][icon]:render();
												end;
											end;
											if categoryTyp == 15 then
												moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][2], moSetGetOverlays.foreignIcons["digiClock"][1].x-(moSetGetOverlays.foreignIcons["digiClock"][1].width/2)-(distanceAppIconWidth/2), moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
												moSetGetOverlays.foreignIcons["digiClock"][2]:render();
												for _, icon in pairs(digiClockIcons.seconds[1]) do
													moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][icon], moSetGetOverlays.foreignIcons["digiClock"][1].x, moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
													moSetGetOverlays.foreignIcons["digiClock"][icon]:render();
												end;
												for _, icon in pairs(digiClockIcons.seconds[2]) do
													moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["digiClock"][icon], moSetGetOverlays.foreignIcons["digiClock"][1].x, moSetGetOverlays.foreignIcons["digiClock"][1].y, moSetGetOverlays.foreignIcons["digiClock"][1].width, moSetGetOverlays.foreignIcons["digiClock"][1].height);
													moSetGetOverlays.foreignIcons["digiClock"][icon]:render();
												end;
											end;
										end;
										renderOverlay = false;	
									elseif category == "SEASONS" then
										lastMoneyIcon = false;
										if MultiOverlayV3.otherMods.seasons == nil or g_seasons == nil then
											local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
											local txt = "Seasons"
											local optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
											optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
											setTextColor(unpack(moColors.intern["red"]));
											setTextAlignment(1);
											setTextBold(true);
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(iconHeigt)+verticalTxtDistance, optiSize, tostring("needs"));
											renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize, tostring(txt));
											setTextAlignment(0);													
											setTextColor(1, 1, 1, 1);
											setTextBold(false);
											renderOverlay = false;
										else
											if categoryTyp >= 1 and categoryTyp <= 4 then
												local currentSeason = g_seasons.weather.environment.season;
												local currentPeriod = g_seasons.weather.environment.period;
												local s1, s2 = 0,0;
												if categoryTyp == 1 then s1,s2=1,4;elseif categoryTyp == 2 then s1,s2=5,8;elseif categoryTyp == 3 then s1,s2=9,12;elseif categoryTyp == 4 then s1,s2=13,16;end;										
												if currentSeason <= 4 then
													local seasonStyleIcon = s1+currentSeason;											
													moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["seasons"][seasonStyleIcon], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
													moSetGetOverlays.foreignIcons["seasons"][seasonStyleIcon]:render();
													local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
													local optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring(txt), 0.015);
													optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring(txt), optiSize);
													setTextColor(unpack(moColors.intern["black"]));
													local txtWidth = getTextWidth(optiSize, tostring(currentPeriod)); -- +2 for month 1-12; + 2 NorthContigent, +6 SouthContigent (later over Settings)
													if categoryTyp == 1 and currentSeason > 1 then setTextColor(unpack(moColors.intern["white"]));end;
													if categoryTyp == 4 then setTextColor(unpack(moColors.intern["red"]));end;
													setTextBold(true);
													renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width-(txtWidth), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+verticalTxtDistance, optiSize, tostring(currentPeriod));
													setTextColor(1, 1, 1, 1);
													setTextBold(false);
												else
													--! season error !
												end;
												renderOverlay = false;
											elseif categoryTyp == 5 or categoryTyp == 6 then	
												local mOn, cropsMoisture = moSetGetExtras:isCropMoisture();
												local fOn, cropsFrozen = moSetGetExtras:isCropFrozen();
												if cropsFrozen or cropsMoisture then
													if categoryTyp == 6 then
														moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["seasonsOther"][3], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
														moSetGetOverlays.foreignIcons["seasonsOther"][3]:render();
														if cropsFrozen then
															moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["seasonsOther"][4], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
															moSetGetOverlays.foreignIcons["seasonsOther"][4]:render();
														elseif cropsMoisture then
															moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["seasonsOther"][5], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
															moSetGetOverlays.foreignIcons["seasonsOther"][5]:render();
														end;
													elseif categoryTyp == 5 then
														if cropsFrozen then
															moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["seasonsOther"][6], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
															moSetGetOverlays.foreignIcons["seasonsOther"][6]:render();
														elseif cropsMoisture then
															moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["seasonsOther"][7], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
															moSetGetOverlays.foreignIcons["seasonsOther"][7]:render();
														end;													
													end;
												else
													moSetGetOverlays:setOverlay(self, moSetGetOverlays.foreignIcons["seasonsOther"][1], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].height);
													moSetGetOverlays.foreignIcons["seasonsOther"][1]:render();
												end;
												renderOverlay = false;
											elseif categoryTyp == 7 or categoryTyp == 8 then
												local iconHeigt = moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2;
												local soilTemp = moSetGetExtras:getSoilTemperature();
												local txt = soilTemp;
												local optiSize = moSetGetExtras:optiHeightSize(self, iconHeigt, tostring("-30 °C"), 0.015);
												optiSize = moSetGetExtras:getWidthOptimalSize(moSetGetOverlays.appIcon[whichSubPDA][iconName].width, tostring("-30 °C"), optiSize);
												local txtHeight = getTextHeight(optiSize-0.001, tostring("-30 °C"));
												setTextColor(unpack(moColors.intern["black"]));
												setTextBold(true);
												setTextAlignment(1);
												renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(moSetGetOverlays.appIcon[whichSubPDA][iconName].height)-txtHeight, optiSize-0.001, tostring(txt));
												setTextAlignment(0);
												setTextColor(1, 1, 1, 1);
												setTextBold(false);											
											end;
										end;									
									end;
								end;
							end;							
							if renderOverlay then
								moSetGetOverlays.appIcon[whichSubPDA][iconName]:render();
							end;
							if g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then
								moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickOpenSetting", renderLine, whichSubPDA, b, iconName);
							else
								moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickNormal", renderLine, whichSubPDA, b, iconName);
							end;
							if iconTyp == 3 and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp] ~= nil and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color ~= nil then
								if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color[3] then
									moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[whichSubPDA][iconName], moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color[1]);
								else
									moSetGetOverlays:setBackgroundColor(moSetGetOverlays.appIcon[whichSubPDA][iconName], moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].color[2]);
								end;
							elseif iconTyp == 4 and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp] ~= nil and string.len(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ".. iconTyp].txt) > 0 then
								setTextColor(unpack(moColors.intern["black"]));
								if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].color ~= nil then setTextColor(unpack(moColors:getColor(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].color, nil, {0,0,0,1})));end;
								--moColors:getColor(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].color, nil, {0,0,0,1})
								local iconTxt = tostring(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].txt);
								local optiSize = moSetGetExtras:optiHeightSize(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2-(verticalTxtDistance), tostring(iconTxt), 0.015);
								if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].size ~= nil then
									if optiSize > moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].size then optiSize = moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].size;end;
								end;
								if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].bold ~= nil then
									setTextBold(moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ"..iconTyp].bold);
								end;
								--local txtHeight = getTextHeight(optiSize, tostring(iconTxt));
								setTextWrapWidth(moSetGetOverlays.appIcon[whichSubPDA][iconName].width-(horizontalTxtDistance));
								setTextLineBounds(0, 2);
								setTextAlignment(1);
								renderText(moSetGetOverlays.appIcon[whichSubPDA][iconName].x+(moSetGetOverlays.appIcon[whichSubPDA][iconName].width/2), moSetGetOverlays.appIcon[whichSubPDA][iconName].y+(moSetGetOverlays.appIcon[whichSubPDA][iconName].height/2)+verticalTxtDistance, optiSize, tostring(iconTxt))
								setTextAlignment(0);
								setTextWrapWidth(0);
								setTextLineBounds(0, 0);
								setTextColor(1, 1, 1, 1);
								setTextBold(false);
							end;
							if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].openMarker ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].openMarker then
								moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["openMarker"], newPosX+(horizontal*(viewAppIcon-1))+distanceAppIconWidth+(horizontal-moSetGetOverlays.pda[whichSubPDA].design["openMarker"].width-distanceAppIconWidth), getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight);
								moSetGetOverlays.pda[whichSubPDA].design["openMarker"]:render();
							end;
						end;
						if moSetGetOverlays.pda[whichSubPDA].line[renderLine].app ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp ~= nil and moSetGetOverlays.pda[whichSubPDA].line[renderLine].app[b].iconTyp == 0 then
							local iconName = "mohIconBlank_";
							moSetGetOverlays:setOverlay(self, moSetGetOverlays.appIcon[whichSubPDA][iconName], newPosX+(horizontal*(viewAppIcon))+distanceAppIconWidth, getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight);
							moSetGetOverlays.appIcon[whichSubPDA][iconName]:render();
							if g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then
								moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickOpenSetting", renderLine, whichSubPDA, b, iconName);
							else
								moDraw.mohPDA:clickAreas(self, moSetGetOverlays.appIcon[whichSubPDA][iconName].x, moSetGetOverlays.appIcon[whichSubPDA][iconName].x+moSetGetOverlays.appIcon[whichSubPDA][iconName].width, moSetGetOverlays.appIcon[whichSubPDA][iconName].y, moSetGetOverlays.appIcon[whichSubPDA][iconName].y+moSetGetOverlays.appIcon[whichSubPDA][iconName].height, "appClickNormal", renderLine, whichSubPDA, b, iconName);
							end;
						end;						
						if g_currentMission.guiMenue.master.isSelectOpenPageGlobalName(MultiOverlayV3.guiMenue.modTable, whichSubPDA, true, true, nil) then --guiMenueSettings:isSelectPageGlobalName(self, whichSubPDA) then
							moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"], newPosX+(horizontal*(viewAppIcon+1))+distanceAppIconWidth-(horizontal/2), getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, horizontal/2.5, vertical/2.5);
							moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["groundSetting"], newPosX+(horizontal*(viewAppIcon+1))+distanceAppIconWidth-(horizontal/2), getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, horizontal/2.5, vertical/2.5);
							moSetGetOverlays:setBackgroundColor(moSetGetOverlays.pda[whichSubPDA].design["groundSetting"], moColors.intern["mangenta"]);							
							if tonumber(appSettingSelect) == tonumber(b) and tonumber(selectSettingLine) == tonumber(renderLine) then
								moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design[11], newPosX+(horizontal*(viewAppIcon)), getUpDownY(posY, vertical*tempViewLines));
								moSetGetOverlays.pda[whichSubPDA].design[11]:render();
								--moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design[11].x, moSetGetOverlays.pda[whichSubPDA].design[11].x+moSetGetOverlays.pda[whichSubPDA].design[11].width, moSetGetOverlays.pda[whichSubPDA].design[11].y, moSetGetOverlays.pda[whichSubPDA].design[11].y+moSetGetOverlays.pda[whichSubPDA].design[11].height, "appSetting", renderLine, whichSubPDA, b);
							end;
							if not moSetGetExtras:runsTimer("3sec", true) and tonumber(selectSettingLine) == tonumber(renderLine) then
								moSetGetOverlays.pda[whichSubPDA].design["groundSetting"]:render();
								if tonumber(appSettingSelect) == tonumber(b) and not moSetGetExtras:runsTimer("1sec", true) then									
									moSetGetOverlays.pda[whichSubPDA].design["otherSetting"]:render();								
								else									
									local infoTxt = tostring(b);
									local optiSize = moSetGetExtras:optiHeightSize(self, moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].height, tostring(infoTxt), 0.009);
									setTextColor(unpack(moColors.intern["mangenta"]));
									setTextBold(true);						
									setTextAlignment(1);
									renderText(moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].x+(moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].width/2.4), moSetGetOverlays.pda[whichSubPDA].design["otherSetting"].y+0.002, optiSize, tostring(infoTxt));
									setTextAlignment(0);
									setTextBold(false);
									setTextColor(1, 1, 1, 1);
								end;
							else
								--warning Icon Test
								--moSetGetOverlays:setBackgroundColor(moSetGetOverlays.pda[whichSubPDA].design["groundSetting"], moColors.intern["red"]);
								--moSetGetOverlays.pda[whichSubPDA].design["groundSetting"]:render();
								--moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["warning"], newPosX+(horizontal*(viewAppIcon+1))+distanceAppIconWidth-(horizontal/2.5), getUpDownY(posY, vertical*tempViewLines)+distanceAppIconHeight, horizontal/2.5, vertical/2.5);
								--moSetGetOverlays.pda[whichSubPDA].design["warning"]:render();
							end;
						end;
						--Setting Open Apps
						viewAppIcon = viewAppIcon+1;						
						if viewAppIcon >= appsAtMasterLine then break;end;
					else
						break;
					end;
				end;
			end;
			tempViewLines = tempViewLines+1;
		end;		
	end;
	if not isHidden then
		if moSetGetOverlays.pda[whichSubPDA].pos.up or posY >= 0.5 then
			for a=1, #moSetGetOverlays.pda[whichSubPDA].renderViewLines do
				setAppIcons(moSetGetOverlays.pda[whichSubPDA].renderViewLines[a]);
			end;
		elseif not moSetGetOverlays.pda[whichSubPDA].pos.up or posY < 0.5 then
			for a=#moSetGetOverlays.pda[whichSubPDA].renderViewLines, 1, -1 do
				setAppIcons(moSetGetOverlays.pda[whichSubPDA].renderViewLines[a]);
			end;
		end;
	end;	
	if moGeneralSettings.setMouseCursor and not isHidden then
		--moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["setting"], newPosX-moSetGetOverlays.pda[whichSubPDA].design["setting"].width/2, posY);
		moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["setting"], posX, posY);
		moSetGetOverlays.pda[whichSubPDA].design["setting"]:render();		
		if not isHidden then moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design["setting"].x, moSetGetOverlays.pda[whichSubPDA].design["setting"].x+moSetGetOverlays.pda[whichSubPDA].design["setting"].width, moSetGetOverlays.pda[whichSubPDA].design["setting"].y, moSetGetOverlays.pda[whichSubPDA].design["setting"].y+moSetGetOverlays.pda[whichSubPDA].design["setting"].height, "pdaSetting", nil, whichSubPDA);end;
		--closeButton
		moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["close"], newPosX+(horizontal*appsAtMasterLine), posY);
		moSetGetOverlays.pda[whichSubPDA].design["close"]:render();	
		if not isHidden then moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design["close"].x, moSetGetOverlays.pda[whichSubPDA].design["close"].x+moSetGetOverlays.pda[whichSubPDA].design["close"].width, moSetGetOverlays.pda[whichSubPDA].design["close"].y, moSetGetOverlays.pda[whichSubPDA].design["close"].y+moSetGetOverlays.pda[whichSubPDA].design["close"].height,	"closePda", nil, whichSubPDA);end;
		--closeButton	
			
			
		if viewLines < #moSetGetOverlays.pda[whichSubPDA].line then			
			moSetGetOverlays:setOverlay(self, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"], newPosX, getUpDownY(posY, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].height, vertical*viewLines));
			moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"]:render();			
			if not isHidden then moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].x, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].x+(moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].width/2), moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].y, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].y+moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].height, "lineUp", nil, whichSubPDA);end;
			if not isHidden then moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].x+(moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].width/2), moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].x+moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].width, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].y, moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].y+moSetGetOverlays.pda[whichSubPDA].design["lineUpDown"].height, "lineDown", nil, whichSubPDA);end;
		end;
		--scroll MasterPDA with mouse lines
		if not isHidden and moSetGetOverlays.pda[whichSubPDA].viewLines < #moSetGetOverlays.pda[whichSubPDA].line then
			moDraw.mohPDA:clickAreas(self, moSetGetOverlays.pda[whichSubPDA].design[1].x+moSetGetOverlays.pda[whichSubPDA].design[1].width, moSetGetOverlays.pda[whichSubPDA].design[3].x, moSetGetOverlays.pda[whichSubPDA].design[7].y+moSetGetOverlays.pda[whichSubPDA].design[7].width+moSetGetOverlays.pda[whichSubPDA].design[7].height, moSetGetOverlays.pda[whichSubPDA].design[3].y, "scrollPDA", nil, whichSubPDA);
		end;		
		--scroll with mouse lines
	end;
	moSetGetOverlays.pda[whichSubPDA].width = width;
	moSetGetOverlays.pda[whichSubPDA].height = height;
	
	moDraw.mohPDA:clickAreas(self, posX, posX+width, posY-height, posY, "hiddenArea", nil, whichSubPDA);
	--moDraw.mohPDA:clickAreas(self, posX, posX+width, posY-height, posY, "totalPdaArea", nil, whichSubPDA); --free,later set global first check mouse at pda total or not 
	
	if not isHidden and g_currentMission.guiMenue.master.isOpen(MultiOverlayV3.guiMenue.modTable) then --and moSetGetExtras:getTimer(self, 0, true) then		
		local pdaName = moSetGetOverlays.pda[whichSubPDA].name or whichSubPDA;
		setTextBold(true);
		if posY-height > 0.06 then renderText(posX, posY-height-getTextHeight(0.0085, tostring(pdaName)), 0.0085, tostring(pdaName));
		elseif posY < 0.95 then renderText(posX, posY+verticalSmall, 0.0085, tostring(pdaName));end;
		setTextBold(false);
	end;	
end;

function getViewLine(self, whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_"
	local viewLine = 1;
	for a=1, #moSetGetOverlays.pda[whichSubPDA].line do
		if moSetGetOverlays.pda[whichSubPDA].line[a] ~= nil then
			if moSetGetOverlays.pda[whichSubPDA].line[a].view then viewLine = a;break;end;
		end;
	end;
	return viewLine;
end;

function moDraw.mohPDA:clickAreas(self, posX, posX1, posY, posY1, whatClick, line, whereClick, appIcon, appIconName)
	local whichSubPDA = tostring(whereClick) or "masterPDA_";
	moGeneralSettings.clickAreas.pda[whichSubPDA][#moGeneralSettings.clickAreas.pda[whichSubPDA]+1] = {
		posX;
		posX1;
		posY;
		posY1;
		whatClick = tostring(whatClick) or "";
		line = line or 0;		
		whereClick = tostring(whereClick) or "";
		appIcon = appIcon or 0;
		appIconName = appIconName or "";
	};
	--moGeneralSettings.clickAreas.primarySlot[#moGeneralSettings.clickAreas.primarySlot+1] = {
	--	posX;
	--	posX1;
	--	posY;
	--	posY1;
	--	whatClick = tostring(whatClick) or "";
	--	line = line or 0;		
	--	whereClick = tostring(whereClick) or "";
	--	appIcon = appIcon or 0;
	--};
end;
